Attribute VB_Name = "mapper17"
Option Explicit

Public Sub map17_write(address As Long, value As Byte)
  Select Case address
    Case &H42FE
    Case &H42FF
    Case &H4501
      map17_irqon = (value And &H1)
    Case &H4502
      map17_irq = &HFF00&
      map17_irq = map17_irq Or value
    Case &H4503
      map17_irq = &HFF
      map17_irq = map17_irq Or value * &H100&
      map17_irqon = 1
    Case &H4504
      reg8 = value
      Call SetupBanks
    Case &H4505
      regA = value
      Call SetupBanks
    Case &H4506
      regC = value
      Call SetupBanks
    Case &H4507
      regE = value
      Call SetupBanks
    Case &H4510 To &H4517
      Call Select1KVROM(value, (address - &H4510))
  End Select
End Sub

Public Sub map17_doirq()
  If map17_irqon Then
    map17_irq = (map17_irq + 1)
    If map17_irq = &H10000 Then
      Call irq6502
      map17_irqon = False
      map17_irq = 0
    End If
  End If
End Sub

