Attribute VB_Name = "settings"
Public EmulatorVersion As String
Public EmulatorReleasedDate As String

Public ShowZoomInfoOnConsoleYESorNO As Integer

Public ShowFPSInfo As Integer
Public EmuVolPUB As Long
Public GotLostFocus As Integer
Public EnabledOPSound As Integer
Public ShowConsole As Integer
Public EnaAComboShoot As Integer
Public EnaBComboShoot As Integer
Public EnaAComboShoot_2P As Integer
Public EnaBComboShoot_2P As Integer
Public sHOWFramesInfo As Integer
Public IgnoreNESErrHeader As Integer
Public AutoSaveConfig As Integer
Public AutoShowColorCount As Integer

'CByte, CInt, CLng, CSByte, CShort, CUInt, CULng,CUShort
Public Sub LoadConfig()
  EmulatorVersion = "Olafnes Rebuild Version 0.02"
  EmulatorReleasedDate = "Released Date:2007-08-10"
  frmNES.ConsoleText.Text = "Initiating..." & "" & vbCrLf & vbCrLf & EmulatorVersion & vbCrLf & EmulatorReleasedDate & vbCrLf & "(C) kevin (olaf) miller & FantasyNoFF"
  
  ShowFPSInfo = GetSetting("olafnes", "window", "showfps", CByte(0))
  If ShowFPSInfo = "1" Then
     frmNES.mnu_ocFPS.Checked = True
     frmNES.mnu_ShowFPS.Visible = True
     frmNES.StatusBar_Timer.Enabled = True
     frmNES.ConsoleText.Text = "show FPS info." & vbCrLf & frmNES.ConsoleText.Text
  Else
     frmNES.mnu_ocFPS.Checked = False
     frmNES.mnu_ShowFPS.Visible = False
     frmNES.StatusBar_Timer.Enabled = False
     frmNES.ConsoleText.Text = "hide FPS info." & vbCrLf & frmNES.ConsoleText.Text
  End If
  
  EmuVolPUB = GetSetting("olafnes", "stuff", "emuvol", CByte(80))
  
  GotLostFocus = GetSetting("olafnes", "window", "focus", CByte(1))
  If GotLostFocus = "1" Then
     frmNES.mnu_AutoPause.Checked = True
     frmNES.Timer2.Enabled = True
     frmNES.ConsoleText.Text = "auto pause enabled." & vbCrLf & frmNES.ConsoleText.Text
  Else
     frmNES.mnu_AutoPause.Checked = False
     frmNES.Timer2.Enabled = False
     frmNES.ConsoleText.Text = "auto pause disabled." & vbCrLf & frmNES.ConsoleText.Text
  End If
  
  EnabledOPSound = GetSetting("olafnes", "stuff", "opsound", CByte(0))
  If EnabledOPSound = "1" Then
     frmNES.mnu_OPSound.Checked = True
     frmNES.ConsoleText.Text = "opening sound enabled." & vbCrLf & frmNES.ConsoleText.Text
  Else
     frmNES.mnu_OPSound.Checked = False
     frmNES.ConsoleText.Text = "opening sound disabled." & vbCrLf & frmNES.ConsoleText.Text
  End If
  
  ShowConsole = GetSetting("olafnes", "stuff", "showcon", CByte(0))
  If ShowConsole = "1" Then
     frmNES.mnu_showConsole.Checked = True
     frmNES.ConsoleText.Text = "console enabled." & vbCrLf & frmNES.ConsoleText.Text
  Else
     frmNES.mnu_showConsole.Checked = False
     frmNES.ConsoleText.Text = "console disabled." & vbCrLf & frmNES.ConsoleText.Text
     frmNES.ConsoleText.Visible = False
  End If
  
  JOY_B = CLng(GetSetting("olafnes", "joystick1", "b", CLng(JOY_BUTTON1)))
  JOY_A = CLng(GetSetting("olafnes", "joystick1", "a", CLng(JOY_BUTTON2)))
  JOY_SEL = CLng(GetSetting("olafnes", "joystick1", "select", CLng(JOY_BUTTON3)))
  JOY_STA = CLng(GetSetting("olafnes", "joystick1", "start", CLng(JOY_BUTTON4)))
  JOY_TURBO = CLng(GetSetting("olafnes", "joystick1", "turbo", CLng(JOY_BUTTON5)))
  JOY2_B = CLng(GetSetting("olafnes", "joystick2", "b", CLng(JOY_BUTTON1)))
  JOY2_A = CLng(GetSetting("olafnes", "joystick2", "a", CLng(JOY_BUTTON2)))
  JOY2_SEL = CLng(GetSetting("olafnes", "joystick2", "select", CLng(JOY_BUTTON3)))
  JOY2_STA = CLng(GetSetting("olafnes", "joystick2", "start", CLng(JOY_BUTTON4)))
  JOY2_TURBO = CLng(GetSetting("olafnes", "joystick2", "turbo", CLng(JOY_BUTTON5)))
  JOYWHICH1 = CInt(GetSetting("olafnes", "joystick1", "which1", CInt(0)))
  JOYWHICH2 = CInt(GetSetting("olafnes", "joystick2", "which2", CInt(0)))
  nes_ButB = CByte(GetSetting("olafnes", "player1", "b", CByte(vbKeyJ)))
  nes_ButA = CByte(GetSetting("olafnes", "player1", "a", CByte(vbKeyK)))
  nes_ButSel = CByte(GetSetting("olafnes", "player1", "select", CByte(vbKeyE)))
  nes_ButSta = CByte(GetSetting("olafnes", "player1", "start", CByte(vbKeyH)))
  nes_ButUp = CByte(GetSetting("olafnes", "player1", "up", CByte(vbKeyW)))
  nes_ButDn = CByte(GetSetting("olafnes", "player1", "down", CByte(vbKeyS)))
  nes_ButLt = CByte(GetSetting("olafnes", "player1", "left", CByte(vbKeyA)))
  nes_ButRt = CByte(GetSetting("olafnes", "player1", "right", CByte(vbKeyD)))
  nes_ButTurbo = CByte(GetSetting("olafnes", "player1", "turbo", CByte(192)))
  nes2_ButB = CByte(GetSetting("olafnes", "player2", "b", CByte(0)))
  nes2_ButA = CByte(GetSetting("olafnes", "player2", "a", CByte(0)))
  nes2_ButSel = CByte(GetSetting("olafnes", "player2", "select", CByte(0)))
  nes2_ButSta = CByte(GetSetting("olafnes", "player2", "start", CByte(0)))
  nes2_ButUp = CByte(GetSetting("olafnes", "player2", "up", CByte(0)))
  nes2_ButDn = CByte(GetSetting("olafnes", "player2", "down", CByte(0)))
  nes2_ButLt = CByte(GetSetting("olafnes", "player2", "left", CByte(0)))
  nes2_ButRt = CByte(GetSetting("olafnes", "player2", "right", CByte(0)))
  nes2_ButTurbo = CByte(GetSetting("olafnes", "player2", "turbo", CByte(0)))
  nes_usesgamepad = CInt(GetSetting("olafnes", "player1", "usesgamepad", CInt(0)))
  nes2_usesgamepad = CInt(GetSetting("olafnes", "player2", "usesgamepad", CInt(0)))
  doSound = CBool(GetSetting("olafnes", "stuff", "dosound", CBool(True)))
  Smooth2x = CInt(GetSetting("olafnes", "stuff", "smooth2x", CInt(0)))
  MotionBlur = CBool(GetSetting("olafnes", "stuff", "motionblur", CBool(False)))
  FrameSkip = CInt(GetSetting("olafnes", "stuff", "frameskip", CInt(1)))
  frmNES.Top = CInt(GetSetting("olafnes", "window", "top", CInt(0)))
  frmNES.Left = CInt(GetSetting("olafnes", "window", "left", CInt(0)))
  
  If MotionBlur = "True" Then
     frmNES.mMotionBlur.Checked = True
     frmNES.ConsoleText.Text = "motionblur enabled." & vbCrLf & frmNES.ConsoleText.Text
  Else
     frmNES.mMotionBlur.Checked = True
     frmNES.ConsoleText.Text = "motionblur disabled." & vbCrLf & frmNES.ConsoleText.Text
  End If
  
  AutoSaveConfig = GetSetting("olafnes", "stuff", "autosavecfg", CByte(1))
  If AutoSaveConfig = "1" Then
     frmNES.mnu_AutoSaveCfg.Checked = True
     frmNES.ConsoleText.Text = "auto save enabled." & vbCrLf & frmNES.ConsoleText.Text
  Else
     frmNES.mnu_AutoSaveCfg.Checked = False
     frmNES.ConsoleText.Text = "auto save disabled." & vbCrLf & frmNES.ConsoleText.Text
  End If
  
  EnaAComboShoot = GetSetting("olafnes", "stuff", "enaacombo", CByte(1))
  If EnaAComboShoot = "1" Then
     frmNES.mnu_EnaAComboShoot.Checked = True
     frmNES.ConsoleText.Text = "1P - joystick key A combo enabled." & vbCrLf & frmNES.ConsoleText.Text
  Else
     frmNES.mnu_EnaAComboShoot.Checked = False
     frmNES.ConsoleText.Text = "1P - joystick key A combo disabled." & vbCrLf & frmNES.ConsoleText.Text
  End If
  
  EnaBComboShoot = GetSetting("olafnes", "stuff", "enabcombo", CInt(1))
  If EnaBComboShoot = "1" Then
     frmNES.mnu_EnaBComboShoot.Checked = True
     frmNES.ConsoleText.Text = "1P - joystick key B combo enabled." & vbCrLf & frmNES.ConsoleText.Text
  Else
     frmNES.mnu_EnaBComboShoot.Checked = False
     frmNES.ConsoleText.Text = "1P - joystick key B combo disabled." & vbCrLf & frmNES.ConsoleText.Text
  End If
  
  EnaAComboShoot_2P = GetSetting("olafnes", "stuff", "enaacombo2p", CInt(1))
  If EnaAComboShoot_2P = "1" Then
     frmNES.mnu_2P_EnaAComboShoot.Checked = True
     frmNES.ConsoleText.Text = "2P - joystick key A combo enabled." & vbCrLf & frmNES.ConsoleText.Text
  Else
     frmNES.mnu_2P_EnaAComboShoot.Checked = False
     frmNES.ConsoleText.Text = "2P - joystick key A combo disabled." & vbCrLf & frmNES.ConsoleText.Text
  End If
  
  EnaBComboShoot_2P = GetSetting("olafnes", "stuff", "enabcombo2p", CInt(1))
  If EnaBComboShoot_2P = "1" Then
     frmNES.mnu_2P_EnaBComboShoot.Checked = True
     frmNES.ConsoleText.Text = "2P - joystick key B combo enabled." & vbCrLf & frmNES.ConsoleText.Text
  Else
     frmNES.mnu_2P_EnaBComboShoot.Checked = False
     frmNES.ConsoleText.Text = "2P - joystick key B combo disabled." & vbCrLf & frmNES.ConsoleText.Text
  End If
  
  sHOWFramesInfo = GetSetting("olafnes", "window", "showframesinfo", CByte(0))
  If sHOWFramesInfo = "1" Then
     frmNES.mnu_ocFrames.Checked = True
     frmNES.frmNES_ShowFrames.Enabled = True
     frmNES.mnu_ShowFrames.Visible = True
     frmNES.ConsoleText.Text = "show frames info." & vbCrLf & frmNES.ConsoleText.Text
  Else
     frmNES.mnu_ocFrames.Checked = False
     frmNES.frmNES_ShowFrames.Enabled = False
     frmNES.mnu_ShowFrames.Visible = False
     frmNES.ConsoleText.Text = "hide frames info." & vbCrLf & frmNES.ConsoleText.Text
  End If
  
  IgnoreNESErrHeader = GetSetting("olafnes", "stuff", "ignoreerrheader", CByte(0))
  If IgnoreNESErrHeader = "1" Then
     frmNES.mnu_IgnoreErrHeader.Checked = True
     frmNES.ConsoleText.Text = "ingore invalid nes header." & vbCrLf & frmNES.ConsoleText.Text
  Else
     frmNES.mnu_IgnoreErrHeader.Checked = False
     frmNES.ConsoleText.Text = "cannot ignore invalid nes header." & vbCrLf & frmNES.ConsoleText.Text
  End If
  
  If doSound = True Then
     frmNES.mMute.Checked = False
     frmNES.ConsoleText.Text = "sound enabled." & vbCrLf & frmNES.ConsoleText.Text
  Else
     frmNES.mMute.Checked = True
     frmNES.ConsoleText.Text = "sound disabled." & vbCrLf & frmNES.ConsoleText.Text
  End If
  frmNES.ConsoleText.Text = "top:" & frmNES.Top & vbCrLf & frmNES.ConsoleText.Text
  frmNES.ConsoleText.Text = "left:" & frmNES.Left & vbCrLf & frmNES.ConsoleText.Text
End Sub

Public Sub SaveConfig()
  Call SaveSetting("olafnes", "player1", "usesgamepad", Str(CInt(nes_usesgamepad)))
  Call SaveSetting("olafnes", "player2", "usesgamepad", Str(CInt(nes2_usesgamepad)))
  Call SaveSetting("olafnes", "joystick1", "b", Str(CLng(JOY_B)))
  Call SaveSetting("olafnes", "joystick1", "a", Str(CLng(JOY_A)))
  Call SaveSetting("olafnes", "joystick1", "select", Str(CLng(JOY_SEL)))
  Call SaveSetting("olafnes", "joystick1", "start", Str(CLng(JOY_STA)))
  Call SaveSetting("olafnes", "joystick1", "turbo", Str(CLng(JOY_TURBO)))
  Call SaveSetting("olafnes", "joystick1", "which1", Str(CInt(JOYWHICH1)))
  Call SaveSetting("olafnes", "joystick2", "b", Str(CLng(JOY2_B)))
  Call SaveSetting("olafnes", "joystick2", "a", Str(CLng(JOY2_A)))
  Call SaveSetting("olafnes", "joystick2", "select", Str(CLng(JOY2_SEL)))
  Call SaveSetting("olafnes", "joystick2", "start", Str(CLng(JOY2_STA)))
  Call SaveSetting("olafnes", "joystick2", "turbo", Str(CLng(JOY2_TURBO)))
  Call SaveSetting("olafnes", "joystick2", "which2", Str(CInt(JOYWHICH2)))
  Call SaveSetting("olafnes", "player1", "b", Str(CByte(nes_ButB)))
  Call SaveSetting("olafnes", "player1", "a", Str(CByte(nes_ButA)))
  Call SaveSetting("olafnes", "player1", "select", Str(CByte(nes_ButSel)))
  Call SaveSetting("olafnes", "player1", "start", Str(CByte(nes_ButSta)))
  Call SaveSetting("olafnes", "player1", "up", Str(CByte(nes_ButUp)))
  Call SaveSetting("olafnes", "player1", "down", Str(CByte(nes_ButDn)))
  Call SaveSetting("olafnes", "player1", "left", Str(CByte(nes_ButLt)))
  Call SaveSetting("olafnes", "player1", "right", Str(CByte(nes_ButRt)))
  Call SaveSetting("olafnes", "player1", "turbo", Str(CByte(nes_ButTurbo)))
  Call SaveSetting("olafnes", "player2", "b", Str(CByte(nes2_ButB)))
  Call SaveSetting("olafnes", "player2", "a", Str(CByte(nes2_ButA)))
  Call SaveSetting("olafnes", "player2", "select", Str(CByte(nes2_ButSel)))
  Call SaveSetting("olafnes", "player2", "start", Str(CByte(nes2_ButSta)))
  Call SaveSetting("olafnes", "player2", "up", Str(CByte(nes2_ButUp)))
  Call SaveSetting("olafnes", "player2", "down", Str(CByte(nes2_ButDn)))
  Call SaveSetting("olafnes", "player2", "left", Str(CByte(nes2_ButLt)))
  Call SaveSetting("olafnes", "player2", "right", Str(CByte(nes2_ButRt)))
  Call SaveSetting("olafnes", "player2", "turbo", Str(CByte(nes2_ButTurbo)))
  Call SaveSetting("olafnes", "stuff", "dosound", Str(CBool(doSound)))
  Call SaveSetting("olafnes", "stuff", "smooth2x", Str(CInt(Smooth2x)))
  Call SaveSetting("olafnes", "stuff", "motionblur", Str(CBool(MotionBlur)))
  Call SaveSetting("olafnes", "stuff", "frameskip", Str(CInt(FrameSkip)))
  Call SaveSetting("olafnes", "window", "top", Str(CInt(frmNES.Top)))
  Call SaveSetting("olafnes", "window", "left", Str(CInt(frmNES.Left)))
  
  
  Call SaveSetting("olafnes", "stuff", "emuvol", EmuVolPUB)
  Call SaveSetting("olafnes", "window", "showfps", ShowFPSInfo)
  Call SaveSetting("olafnes", "window", "focus", GotLostFocus)
  Call SaveSetting("olafnes", "stuff", "opsound", EnabledOPSound)
  Call SaveSetting("olafnes", "stuff", "showcon", ShowConsole)
  Call SaveSetting("olafnes", "stuff", "enaacombo", EnaAComboShoot)
  Call SaveSetting("olafnes", "stuff", "enabcombo", EnaBComboShoot)
  Call SaveSetting("olafnes", "stuff", "enaacombo2p", EnaAComboShoot_2P)
  Call SaveSetting("olafnes", "stuff", "enabcombo2p", EnaBComboShoot_2P)
  Call SaveSetting("olafnes", "window", "showframesinfo", sHOWFramesInfo)
  Call SaveSetting("olafnes", "stuff", "ignoreerrheader", IgnoreNESErrHeader)
  Call SaveSetting("olafnes", "stuff", "autosavecfg", AutoSaveConfig)
End Sub
