Attribute VB_Name = "mapper4"
Option Explicit

Public Sub map4_sync()
  If swap Then
    reg8 = &HFE
    regA = PrgSwitch2
    regC = PrgSwitch1
    regE = &HFF
  Else
    reg8 = PrgSwitch1
    regA = PrgSwitch2
    regC = &HFE
    regE = &HFF
  End If
  Call SetupBanks
End Sub

'Public Function map4_hblankbackup(Scanline, two As Byte) As Boolean
  ''original version
  'If Scanline = 0 Then
    'MMC3_IrqVal = MMC3_TmpVal
  'ElseIf Scanline > 239 Then
    'Exit Function
  'ElseIf MMC3_IrqOn And (two And &H18) Then
    'MMC3_IrqVal = (MMC3_IrqVal - 1) And &HFF
    'If (MMC3_IrqVal = 0) Then
      'Call irq6502
      'MMC3_IrqVal = MMC3_TmpVal
    'End If
  'End If
'End Function

Public Sub map4_write(Address As Long, value As Byte)
  'original version
  Select Case Address
    Case &H8000&
      MMC3_Command = value And &H7
      If value And &H80 Then
        MMC3_ChrAddr = &H1000&
      Else
        MMC3_ChrAddr = 0
      End If
      If value And &H40 Then
        swap = 1
      Else
        swap = 0
      End If
    Case &H8001&
      Select Case MMC3_Command
        Case 0
          Call Select1KVROM(value, 0)
          Call Select1KVROM(value + 1, 1)
        Case 1
          Call Select1KVROM(value, 2)
          Call Select1KVROM(value + 1, 3)
        Case 2
          Call Select1KVROM(value, 4)
       Case 3
          Call Select1KVROM(value, 5)
        Case 4
          Call Select1KVROM(value, 6)
        Case 5
          Call Select1KVROM(value, 7)
        Case 6
          PrgSwitch1 = value
          Call map4_sync
        Case 7
          PrgSwitch2 = value
          Call map4_sync
      End Select
    Case &HA000&
      If value And 1 Then
        Mirroring = 0
      Else
        Mirroring = 1
      End If
      Call domirror
    Case &HA001&
      If value Then
        UsesSRAM = True
      Else
        UsesSRAM = False
      End If
    Case &HC000&
      MMC3_IrqVal = value
    Case &HC001&
      MMC3_TmpVal = value
    Case &HE000&
      MMC3_IrqOn = False
      MMC3_IrqVal = MMC3_TmpVal
    Case &HE001&
      MMC3_IrqOn = True
  End Select
End Sub

Public Function map4_hblank(Scanline, two As Byte) As Boolean
  'disch's fix version
  If Scanline > 239 Then
    Exit Function
  ElseIf (two And &H18) Then
    If MMC3_IrqVal = 1 Then
      If (MMC3_IrqOn) Then
        Call irq6502
      End If
    ElseIf MMC3_IrqVal = 0 Then
      MMC3_IrqVal = MMC3_TmpVal
    Else
      MMC3_IrqVal = MMC3_IrqVal - 1
    End If
  End If
End Function

'Public Sub map4_writebackup(Address As Long, value As Byte)
  ''disch's fix version
  'Select Case Address
    'Case &H8000&
      'MMC3_Command = value And &H7
      'If value And &H40 Then
        'swap = 1
      'Else
        'swap = 0
      'End If
      'If value And &H80 Then
        'MMC3_ChrAddr = &H1000&
      'Else
        'MMC3_ChrAddr = 0
      'End If
    'Case &H8001&
      'Select Case MMC3_Command
        'Case &H0
          'Call select1kvrom(value, 0)
          'Call select1kvrom(value + 1, 1)
        'Case &H1
          'Call select1kvrom(value, 2)
          'Call select1kvrom(value + 1, 3)
        'Case &H2
          'Call select1kvrom(value, 4)
        'Case &H3
          'Call select1kvrom(value, 5)
        'Case &H4
          'Call select1kvrom(value, 6)
        'Case &H5
          'Call select1kvrom(value, 7)
        'Case &H6
          'PrgSwitch1 = value
          'Call map4_sync
        'Case &H7
          'PrgSwitch2 = value
          'Call map4_sync
      'End Select
    'Case &HA000&
      'If value And &H1 Then
        'Mirroring = 0
      'Else
        'Mirroring = 1
      'End If
      'Call domirror
    'Case &HA001&
      'If value Then
        'UsesSRAM = True
      'Else
        'UsesSRAM = False
      'End If
    'Case &HC000&
      'MMC3_TmpVal = value
    'Case &HC001&
      'MMC3_IrqVal = 0
    'Case &HE000&
      'MMC3_IrqOn = False
    'Case &HE001&
      'MMC3_IrqOn = True
  'End Select
'End Sub
