Attribute VB_Name = "mapper40"
Option Explicit

Public Sub map40_irq()
  If Mapper40_IRQEnabled = 1 Then
    Mapper40_IRQCounter = (Mapper40_IRQCounter - 1) And 36
    If Mapper40_IRQCounter = 0 Then
      Call irq6502
    End If
  End If
End Sub

Public Sub map40_write(address As Long, value As Byte)
  Select Case (address And &HE000&)
    Case &H8000&
      Mapper40_IRQEnabled = 0
      Mapper40_IRQCounter = 36
    Case &HA000&
      Mapper40_IRQEnabled = 1
    Case &HE000&
      regC = value
      Call SetupBanks
  End Select
End Sub

