Attribute VB_Name = "mapper9"
Option Explicit

Public Sub map9_latch(TileNum As Byte, Hi As Boolean)
  If Mapper <> 9 Then
    Exit Sub
  End If
  If (TileNum = &HFD) Then
    If (Hi = False) Then
      Call Select4KVROM(Latch0FD, 0)
      latch1 = &HFD
    ElseIf (Hi = True) Then
      Call Select4KVROM(Latch1FD, 1)
      latch2 = &HFD
    End If
  ElseIf (TileNum = &HFE) Then
    If (Hi = False) Then
      Call Select4KVROM(Latch0FE, 0)
      latch1 = &HFE
    ElseIf (Hi = True) Then
      Call Select4KVROM(Latch1FE, 1)
      latch2 = &HFE
    End If
  End If
End Sub

Public Sub map9_write(address As Long, value As Byte)
  Static bnk As Long
  Select Case (address And &HF000&)
    Case &HA000&
      Select Case Mapper
        Case 9
          reg8 = value
        Case 10
          reg8 = value * 2
          regA = reg8 + 1
      End Select
      Call SetupBanks
    Case &HB000&
      Latch0FD = value
      If latch1 = &HFD Then
        Call Select4KVROM(value, 0)
      End If
    Case &HC000&
      Latch0FE = value
      If latch1 = &HFE Then
        Call Select4KVROM(value, 0)
      End If
    Case &HD000&
      Latch1FD = value
      If latch2 = &HFD Then
        Call Select4KVROM(value, 1)
      End If
    Case &HE000&
      Latch1FE = value
      If latch2 = &HFE Then
        Call Select4KVROM(value, 1)
      End If
    Case &HF000&
      If (value And 1) Then
        Mirroring = 0
      ElseIf (value And 1) = 0 Then
        Mirroring = 1
      End If
  End Select
End Sub

